<!-- Reserved app names -->
<div class="app-modal">
  <div class="app-modal-header bg-dark d-flex flex-row justify-content-between">General Configurations</div>
  <div class="app-modal-body">

    <!-- Display -->
    <div class="general-config-display">
      <label class="mb-1">
        <strong>Reserved names (apps cannot be any of these)</strong>
        <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Users cannot set their app identifiers to any of the names that you specify here. For example, if you specify 'myapp' as a reserved name, no user can set their app id to 'myapp', and no app will have a URL 'myapp.{{ general_config.domain }}'"></i>
      </label>
      {% with reserved_app_names=general_config.get_reserved_app_names %}
        {% if reserved_app_names|length == 0 %}
          <div class="ms-2 text-secondary">No reserved app names. Click "Edit" to add some.</div>
        {% else %}
          <div class="mt-1 tags-container">
            {% for app in reserved_app_names %}
              <div class="tag">{{ app }}</div>
            {% endfor %}
          </div>
        {% endif %}
      {% endwith %}

      <div class="row mt-3 mb-1">
        <strong class="col col-md-3">
          Terraform module
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Terraform module used to create resources (e.g. Keycloak client, PostgreSQL roles and database, Helm chart, etc) for each app"></i>
        </strong>
        <pre class="col col-md-9 mb-0"><code>{% if general_config.terraform_module %}{{ general_config.terraform_module }}{% else %}Not set{% endif %}</code></pre>
      </div>

      <div class="row my-1">
        <strong class="col col-md-3">
          Helm chart
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Helm chart used to deploy K8s resources for each app (deployment, service, ingressroutes, etc). This Helm chart is deployed by the Terraform module above"></i>
        </strong>
        <pre class="col col-md-9 mb-0"><code>{% if general_config.helm_chart %}{{ general_config.helm_chart }}{% else %}Not set{% endif %}</code></pre>
      </div>

      <div class="row my-1">
        <strong class="col col-md-3">
          STRAP Domain
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Domain that each app will have after a successful deployment. For example, if you set the domain to 'mydomain.com', an app with id 'myapp' will have a URL 'myapp.mydomain.com'"></i>
        </strong>
        <pre class="col col-md-9 mb-0"><code>{% if general_config.domain %}{{ general_config.domain }}{% else %}Not set{% endif %}</code></pre>
      </div>

      <div class="row my-1">
        <strong class="col col-md-3">
          Preset IP addresses/networks
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Each app can choose to only allow these preset IPs to access the app"></i>
        </strong>
        {% if preset_ips.keys|length > 0 %}
          <div class="col col-md-9">
            {% for name, ips in preset_ips.items %}
            <pre class="mb-0"><code>{{ name }}: {{ ips|join:", " }}</code></pre>
            {% endfor %}
          </div>
        {% else %}
          <pre class="col col-md-9 mb-0"><code>Not set</code></pre>
        {% endif %}
      </div>

      <button type="button" class="btn btn-outline-dark btn-sm mt-3 edit-btn">Edit</button>
    </div>

    <!-- Form -->
    <form
      action="{% url 'update_general_config' %}"
      method="post"
      class="general-config-form d-none">
      <label class="mb-2">
        <strong>Reserved names (app ids cannot be any of these)</strong>
        <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Users cannot set their app identifiers to any of the names that you specify here. For example, if you specify 'myapp' as a reserved name, no user can set their app id to 'myapp', and no app will have a URL 'myapp.{{ general_config.domain }}'"></i>
      </label>
      {% csrf_token %}

      <!-- Reserved name apps -->
      <textarea
        name="reserved_app_names"
        class="form-control"
        placeholder='List of names that users cannot set their app id to. Must match a certain format'
        rows="5">{% if general_config.reserved_app_names %}{{ general_config.reserved_app_names }}{% endif %}</textarea>
      <div class="form-text reserved-app-names-requirements mb-3">
        Separate reserved names by a new line. All white spaces in each name will be removed.
      </div>

      <!-- Terraform module -->
      <div class="mb-3">
        <label for="terraform-module" class="form-label">
          <strong>Terraform module</strong>
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Terraform module used to create resources (e.g. Keycloak client, PostgreSQL roles and database, Helm chart, etc) for each app"></i>
        </label>
        <input
          type="text"
          name="terraform_module"
          class="form-control"
          id="terraform-module"
          aria-describedby="terraformModuleHelp"
          placeholder="e.g. git::https://gitlab.example.com/path/to/your/terraform.git"
          {% if general_config.terraform_module %}value="{{ general_config.terraform_module }}"{% endif %}>
        <div id="terraformModuleHelp" class="form-text">Specify a remote or a local path to your Terraform module</div>
      </div>

      <!-- Helm chart -->
      <div class="mb-3">
        <label for="helm-chart" class="form-label">
          <strong>Helm chart</strong>
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Helm chart used to deploy K8s resources for each app (deployment, service, ingressroutes, etc). This Helm chart is deployed by the Terraform module above"></i>
        </label>
        <input
          type="text"
          name="helm_chart"
          class="form-control"
          id="helm-chart"
          aria-describedby="helmChartHelp"
          placeholder="e.g. https://gitlab.example.com/path/to/your/helm/chart"
          {% if general_config.helm_chart %}value="{{ general_config.helm_chart }}"{% endif %}>
        <div id="helmChartHelp" class="form-text">Specify a remote or a local path to your Helm chart</div>
      </div>

      <!-- Domain -->
      <div class="mb-3">
        <label for="strap-domain" class="form-label">
          <strong>STRAP Domain</strong>
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Domain that each app will have after a successful deployment. For example, if you set the domain to 'mydomain.com', an app with id 'myapp' will have a URL 'myapp.mydomain.com'"></i>
        </label>
        <input
          type="text"
          name="domain"
          class="form-control"
          id="strap-domain"
          aria-describedby="strapDomainHelp"
          placeholder="e.g. example.com"
          {% if general_config.domain %}value="{{ general_config.domain }}"{% endif %}>
        <div id="strapDomainHelp" class="form-text">Specify the domain name for the STRAP platform</div>
      </div>

      <!-- Preset IP addresses/networks -->
      <div class="mb-3" id="preset-ips-editor">
        <label for="strap-domain" class="form-label">
          <strong>Preset IP addresses/networks</strong>
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Each app can choose to only allow these preset IPs to access the app"></i>
        </label>

        <div class="ps-2">
          <div id="ip-option-blocks">
            {% if preset_ips.keys|length > 0 %}
              {% for name, ips in preset_ips.items %}
                <div
                  {% if forloop.first %}
                    class="ip-option-block"
                  {% else %}
                    class="ip-option-block mt-3 pt-3 border-top border-dark"
                  {% endif %}>
                  <div class="d-flex flex-row justify-content-end">
                    <button class="btn btn-sm btn-outline-danger ms-auto mb-2">
                      <i class="fa-solid fa-trash me-1"></i>
                      Delete option
                    </button>
                  </div>
                  <div class="ip-option-values">
                    <div class="row">
                      <label class="col-6 fs-90percent fw-light">Name</label>
                      <label class="col-5 fs-90percent fw-light">IP addresses/networks</label>
                      <div class="col-1"></div>
                    </div>

                    {% for ip in ips %}
                      <div class="row my-1">
                        <div class="col-6">
                          {% if forloop.first %}<input type="text" name="preset_ip_name" value="{{ name }}" class="form-control" placeholder="My VPN">{% endif %}
                        </div>
                        <div class="col-5">
                          <input
                            type="text"
                            name="preset_ip_value"
                            value="{{ ip }}"
                            pattern="^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}(/[0-9]{1,2})?$"
                            class="form-control"
                            placeholder="0.0.0.0/0">
                        </div>
                        <div class="col-1 d-flex flex-column justify-content-center align-items-start">
                          <i class="remove-ip-btn fa-solid fa-trash icon-btn-dark my-auto"></i>
                        </div>
                      </div>
                    {% endfor %}
                  </div>

                  <div class="row">
                    <div class="col-6"></div>
                    <div class="add-ip-btn col-5 fs-90percent text-btn-dark mt-2 w-fit">+ Add IP address or network</div>
                    <div class="col-1"></div>
                  </div>

                  <!-- Hidden input that stores all IPs for the option as a comma separated string -->
                  <input type="text" name="preset_ips" class="d-none">
                </div>
              {% endfor %}
            {% else %}
              <div class="ip-option-block">
                <div class="ip-option-values">
                  <div class="row">
                    <label class="col-6 fs-90percent fw-light">Name</label>
                    <label class="col-5 fs-90percent fw-light">IP addresses/networks</label>
                    <div class="col-1"></div>
                  </div>
                  <div class="row my-1">
                    <div class="col-6">
                      <input type="text" name="preset_ip_name" class="form-control" placeholder="My VPN">
                    </div>
                    <div class="col-5">
                      <input
                        type="text"
                        name="preset_ip_value"
                        pattern="^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}(/[0-9]{1,2})?$"
                        class="form-control"
                        placeholder="0.0.0.0/0">
                    </div>
                    <div class="col-1 d-flex flex-column justify-content-center align-items-start">
                      <i class="remove-ip-btn fa-solid fa-trash icon-btn-dark my-auto"></i>
                    </div>
                  </div>
                </div>
                <div class="row">
                  <div class="col-6"></div>
                  <div class="add-ip-btn col-5 fs-90percent text-btn-dark mt-2 w-fit">+ Add IP address or network</div>
                  <div class="col-1"></div>
                </div>

                <!-- Hidden input that stores all IPs for the option as a comma separated string -->
                <input type="text" name="preset_ips" class="d-none">
              </div>
            {% endif %}
          </div>

          <button id="add-ip-option-btn" class="btn btn-sm btn-outline-primary">+ Add IP option</button>
        </div>
      </div>

      <button type="button" class="btn btn-danger btn-sm mt-2 cancel-btn">Cancel</button>
      <button type="submit" class="btn btn-dark btn-sm mt-2">Submit</button>
    </form>

  </div>
</div>
